function [EO,peak]=Calc_OD(imDir,imName,imNumber)
% This function is used to 
% calculate the optical depth from the three images
%('_NoAt','_With','_Back')
%
% Syntax: 
%[EO,peak]=Calc_OD(imDir,imName,imNumber);

im_noat=double(importdata([imDir '/' imName  imNumber '_NoAt' '.tif']));
im_with=double(importdata([imDir '/' imName  imNumber '_With' '.tif']));
im_back=double(importdata([imDir '/' imName  imNumber '_Back' '.tif']));

AT = im_with - im_back ;
BG = im_noat - im_back ;

EO = -log( max (AT(:,:,1),1)./max(1,BG(:,:,1)) );

peak = max(max(EO(~isnan(EO))));