
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                        Infos gnrales                                %%
%Programme dvelopp en 2015 au Laboratoire CAR, quipe Atomes Froids     %
%118, route de Narbonne - 31062 Toulouse Cedex 09 - France                %
%Pour plus d'information contactez                                        %
%Ala Fortun : aelafortun@hotmail.com 
%David Gury-Odelin : dgo@irsamc.ups-tlse.fr
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Programme de mise en forme des donnes et traitement du fond thermique%%
%                                                                         %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%               M file supplmentaires ncssaires :                    %%
%     Calc_OD                                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all;
clear all;
hold off


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                 Dfinition des paramtres gnraux                    %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

imDir='C:\Users\Fortun\Documents\Redaction_thse\Programmes_def\RamanNath_5El_tiff'; %chemin des images
imNom='RamanNath_5El_tof20_pulses'; %nom des images avant le 'temps_0000i_Back/NoAt/With'
PixelSize=2.68; %taille d'un pixel de la camra en m.
Ntemps=41;  %Nombre de temps diffrents.
Dtemps=1; %dt (attention, si le temps n'est pas rgulier, crer le vecteur 
          %Tgrid  la main dans la zone 'Cration de la base de temps
Nmoy=2; %nombre d'image sur lequel on moyenne.
Angle=9;   %Angle de rotation de l'image      

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                   Cration de la base de temps                        %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Tgrid=[0:Ntemps-1]*Dtemps;  
%Tgrid=[550,575,600,625,650,800];%Uniquement si le pas de temps n'est pas
%rgulier

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                    Cration de la base spatiale                       %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
             
        Ncadre=6; %choisir une image typique
        
        imName=strcat(imNom,num2str(Tgrid(Ncadre))); %nom des images avant _0000i_Back/NoAt/With
        imNumber='_00000';

        [Ecadre,peak]=Calc_OD(imDir,imName,imNumber); %appel a la fonction 
                                                     %pour le calcul de la 
                                                     %profondeur optique
        Ecadre=imrotate(Ecadre,Angle);  %rotation de l'image
        
        % Affichage de la figure pour dfinir le cadre  la main sur la
        % console Matlab
        figure(1)
        imagesc(Ecadre)
        title('Choix du cadre')
        xlabel('Direction horizontale : X (pixel)')
        ylabel('Direction verticale : Y (pixel)')
        %pause
        
             %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Xmin=input('Direction horizontale : Xmin = ');
Xmax=input('Direction horizontale : Xmax = ');      
Ymin=input('Direction verticale (attention aller de haut en bas) : Ymin = ');
Ymax=input('Direction verticale : Ymax = ');
Xgrid=[0:Xmax-Xmin]*PixelSize; %base spatiale horizontale
Ygrid=[0:Ymax-Ymin]*PixelSize; %base spatiale verticale
Npix=Xmax-Xmin+1;




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%               paquet  traiter et cadres correspondants               %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%Pour choisir n et Cadre : 
%%%% On choisi n le nombre de paquet  traiter et Cadre
%%%% qui doit tre dfini comme suit :
%%%%
%%%% Cadre =
%%%% [Xmin(paquet-max),Xmax(paquet-max),...Xmin(paquet0),Xmax(paquet0),Xmin
%%%% (paquet
%%%% +1),Xmax(paquet+1),...,Xmin(paquet+max)Xmax(paquet+max)]
%%%%
%%%%Choisir un cadre bien ressr sur les paquet pour
%%%%pouvoir fiter une gaussienne sur le reste.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                           Choix du cadre bis                          %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%             
        Ncadre=6;
        
        imName=strcat(imNom,num2str(Tgrid(Ncadre))); %nom des images avant _0000i_Back/NoAt/With
        imNumber='_00000';

        [Ecadre,peak]=Calc_OD(imDir,imName,imNumber); %appel a la fonction 
                                                     %pour le calcul de la 
                                                     %profondeur optique
        Ecadre=imrotate(Ecadre,Angle);  %rotation de l'image
        
        Dcadre=sum(Ecadre(Ymin:Ymax,Xmin:Xmax));%selection du cadre  
                                           %EO(Ymin:Ymax,Xmin:Xmax) en 
                                           %numro de pixel
        % Affichage de la figure pour dfinir le cadre bis  la main sur la
        % console Matlab
        figure(1)
        plot(Dcadre)
        title('choix des cadres des paquets')
        xlabel('Aller de la gauche vers la droite')
%         pause
             %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


n=input('combien de pics  traiter ? n= ');
nmax=(n-1)/2;
Cadre =zeros(1,2*n);
for p=1:2*n
    Cadre(p)=input(strcat('Aller de la gauche vers la droite : valeur ',num2str(p),' : '));
end
CadreFond=[1,Cadre(1)-10,Cadre(2*n)+10,Npix];


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                       Boucle sur le temps                             %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for j=0:Ntemps-1    %%%Nombre de temps.
    
    tnum=Tgrid(j+1) % Convertion en temps rel           
    t=num2str(tnum); %%Pour l'extension.
    


        
    for i=0:Nmoy-1 %boucle sur les image d'un temps : 
              
        h=num2str(i);   %pour l'extension 
        

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                  Calcul des images d'absorptions                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




        imName=strcat(imNom,t); %nom des images avant _0000i_Back/NoAt/With
        imNumber=strcat('_0000',h);

        [OptDens,peak]=Calc_OD(imDir,imName,imNumber); %appel a la fonction 
                                                     %Calc_OD
                                                     %pour le calcul de la 
                                                     %profondeur optique
 
 
 
        if (i==0)    
            EO=OptDens;
        else
            EO=EO+OptDens;
        end
 
    end
    
    
    
%     figure(1)
%     imagesc(EO) %%Plot image totale
%     pause

    EO=imrotate(EO,Angle);  %rotation de l'image
    
%     figure(2)
%     imagesc(EO)  %%Plot image rotate
%     pause

    D=EO(Ymin:Ymax,Xmin:Xmax);%selection du cadre EO
    

%     
%     figure(3)
%     imagesc(D)  %%Plot image recadre
%     pause
% % 

%%     matrice sans intgration     %%
 if (j==0)
      globalplot=D;  % initialisation matrice pour film
 else
globalplot=vertcat(globalplot,D);   % creation de la matrice pour film
 end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                  1D                                   %%
%%                              Intgration                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


    integ_X=sum(D); %Sommation selon l'axe vertical
    integ_tot(j+1)=sum(integ_X);
    integ_Xnorm=integ_X./integ_tot(j+1); %Image intgre et normalise  1


%%      matrice avec integration    %%

    if j==0
        globalplotinteg=integ_X;  % initialisation matrice pour film
        globalplotintegnorm=integ_Xnorm;
    else
        globalplotinteg=vertcat(globalplotinteg,integ_X);   % creation de la matrice pour film
        globalplotintegnorm=vertcat(globalplotintegnorm,integ_Xnorm);                                                    %la matrice 
    end
 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                               2D                                     %%
%%                  Reshape de la matrice pour PCA                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    SizeD=size(D);
    Dcut=reshape(D',[1,SizeD(1)*SizeD(2)]);    %transforme l'image D en un 
                                               %vecteur de longueur 
                                               %SizeD(1)*SizeD(2)
    if (j==0)
        globalplot2D=Dcut;   %initialisation matric pour PCA
    else
        globalplot2D=vertcat(globalplot2D,Dcut); % creation de la matrice pour PCA
    end


end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                     Initialisation du fond                            %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Datatherm=globalplotintegnorm; %Initialisation de d'image du fond
Xgridfit=Xgrid; %Grille selon X restreinte aux points restants aprs 
                %avoir enlev les parties condenses (dfinis pas Cadre)    
Fond=zeros(Ntemps,Npix);%Initialisation du fond fitt
Dataclean=zeros(Ntemps,Npix); %Initialisation de l'image reconstruite sans 
                             %le fond
Dataoffset=zeros(Ntemps,Npix); %Initialisation de l'image  laquelle on a 
                                %retir uniquement l'offset

                                
%Retrait de tous les points correspondant aux parties condenses                                
for i=1:n
    Xgridfit(Cadre(2*(n-i)+1):Cadre(2*(n-i)+2))=[];
end
for i=1:n
    Datatherm(:,Cadre(2*(n-i)+1):Cadre(2*(n-i)+2))=[];
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                    Dtermination du fond                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



for t=1:Ntemps
    
    
    %initialisation des variables d'ajustement
    [pks,loc]=findpeaks(globalplotintegnorm(t,:),'MinPeakDistance',20,'MinPeakHeight',0.002);
    [garbage,Npeak]=size(loc);
    
    if t==1
        initcentre=Xgrid(loc(1,floor((Npeak+1)/2))); %On initialise avec le pic central
        initampl=pks(1)/10; %Empiriquement le fond thermique est de l'ordre 
                            % 1/10 des parties condenses. --> A ajuster si
                            % besoin <--
        
    end

    if Npeak==1
        initwidth=20000;    %valeurs empiriques pour la largeur de la 
    elseif Npeak==3         %gaussienne en fonction du nombre de parties
        initwidth=30000;    %condenses
    else
        initwidth=50000;
    end
    
    %Ajustement du fond thermique par une gaussienne
    gaussianfit='A*exp(-(x-B)^2/C)+D';
    gaussianfittype = fittype(gaussianfit,'independent','x');
    fittherm=fit(Xgridfit',Datatherm(t,:)',gaussianfittype,'StartPoint',[initampl,initcentre,initwidth,0],'Algorithm','Levenberg-Marquardt','TolFun',1e-12,'TolX',1e-12);

    %Enregistrement des rsultats de l'ajustement
    Fond(t,:)=fittherm.A*exp(-(Xgrid-fittherm.B).^2./fittherm.C)+fittherm.D;
    Dataclean(t,:)=globalplotintegnorm(t,:)-Fond(t,:);
    Dataclean(t,:)=Dataclean(t,:)/sum(Dataclean(t,:));
    Dataoffset(t,:)=globalplotinteg(t,:)-fittherm.D*integ_tot(t);

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                  Affichage des rsultats                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 figure(1);
 imagesc(globalplotintegnorm)
 title('film intgr selon la verticale')

figure(2)
imagesc(Dataclean) 
title('film intgr selon la verticale et fond trait')

figure(3)
imagesc(Fond)
title('Fond')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                      Sauvegarde des datas                             %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


save(strcat(imNom,'_DonneesCadrage','.txt'),'SizeD','-ascii')
save(strcat(imNom,'_T','.txt'),'Tgrid','-ascii')
save(strcat(imNom,'_X','.txt'),'Xgrid','-ascii')
save(strcat(imNom,'_Y','.txt'),'Ygrid','-ascii')


save(strcat(imNom,'_Normal','.txt'),'globalplot','-ascii')
save(strcat(imNom,'_PCA','.txt'),'globalplot2D','-ascii')
save(strcat(imNom,'_Integ','.txt'),'globalplotinteg','-ascii')
save(strcat(imNom,'_IntegNorm','.txt'),'globalplotintegnorm','-ascii')
save(strcat(imNom,'_DataIntegClean','.txt'),'Dataclean','-ascii')
save(strcat(imNom,'_DataIntegOffset','.txt'),'Dataoffset','-ascii')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                        Liste des outputs                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Tous les fichiers sont des '.txt'
%
%imNom_DonneesCadrage      : taille du cadre restreint choisi [NpixY,NpixX]
%imNom_T/_X/_Y             : 3 fichiers qui sont respectivement
%                            la base de temps, la base spatiale horizontale
%                            du cadre restreint et la base spatiale
%                            verticale du cadre restreint : Tgrid, Xgrid et
%                            Ygrid
%imNom_Normal              : Matrice_film de l'exprience 
%imNom_PCA                 : matrice mise en forme pour la PCA (chaque
%                            ligne de la matrice correspond  une image)
%imNom_Integ               : Chaque image de la matrice_film  t intgr
%                            suivant l'axe vertical. 
%imNom_integNorm           : Chaque image de la matrice_film  t intgr
%                            suivant l'axe vertical et normalis  1. 
%imNom_DataIntegClean      : Film intgr et dont le fond thermique  t
%                            retir
%imNom_DataIntegOffset     : Film intgr, non normalis et dont seul 
%                            l'offset  t trait. Ce fichier est utile si
%                            on veut suivre l'volution du nombre d'atome 
%                            par exemple. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


