
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                        Infos gnrales                                %%
%Programme dvelopp en 2015 au Laboratoire CAR, quipe Atomes Froids     %
%118, route de Narbonne - 31062 Toulouse Cedex 09 - France                %
%Pour plus d'information contactez                                        %
%Ala Fortun : aelafortun@hotmail.com    
%David Gury-Odelin : dgo@irsamc.ups-tlse.fr
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all
clear all
hold off
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                      Diffraction Kapitza-Dirac                        %%
%                                                                         %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%              fichiers supplmentaires ncssaires :                   %%
%   Fichiers gnrs par le programme 'traitement_globalplot_RamanNath :  %
%        imNom_paramfit.txt  : Paramtre des ajustement dans le cadre de  % 
%                              Raman Nath pour comparaison                %
%   imNom_integordrenorm.txt : Evolution du nombre d'atome dans chacun des%
%                              ordres de diffraction                      %
%                imNom_T.txt : Base temporelle correspondant             %
%                              l'exprience                               %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                     Chargement des donnes                            %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%Donnes exprimentales : matrice (Ntemps*Nombre d'ordres  traiter).
%%%%%%Attention, l'ordre des colonnes doit tre : 
%%%%%% ordre-n    ... ordre-1  ordre0  ordre+1 ... ordre+n
%%%%%%Fit Raman Nath des donnes exprimentales : paramfit (les fits sont 
%%%%%%faits dans le programme 'traitement_globalplot_RamanNath.m
%%%%%%fonction :   A*besselj(m,B*x)^2+C
%%%%%%chaque colonne de paramfit est organise comme
%      suit : ligne 1 : numro de l'ordre trait
%             ligne 2 : valeur du parametre A
%             lignes 3&4 : intervalle de confiance 
%                               95% pour le paramtre A
%             ligne 5 : valeur du paramtre B
%             lignes 6&7 : intervalle de confiance
%                                95% pour le paramtre B

imNom='RamanNath_5El_tof20_pulses'; %nom des images avant le 'tempspulse_0000i_Back/NoAt/With'
FitRN=load(strcat(imNom,'_paramfit.txt'));
DataExp=load(strcat(imNom,'_integordrenorm.txt'));
Tgrid=load(strcat(imNom,'_T.txt'));
[Ntemps,ntot]=size(DataExp);
Dtemps=1; %Dtemps doit etre un entier et en s ....

n=(ntot-1)/2; %nombre d'ordre max

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %                 ATTENTION                         %
        %  Le programme actuel ne fonctionne que si le      %
        %    pas de temps est rgulier et ne va que         %
        %               jusqu' 70s                        %
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%          Choix de l'intervalle de profondeur  tester                 %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

smin=2;
smax=7;
dsgrid=[0,2,4,5,6,8];
dTkapitza=0.5; %en s
deltas=smax-smin;
Nsm=deltas+1; %Nombre de valeur entire de profondeur  tester
Ns=(deltas+1)*length(dsgrid); %Nombre totales de valeurs a tester
sgrid=(smin:smax);
sgridtot=zeros(1,Ns); %Grille des valeurs  tester
for i=1:Nsm
    for l=1:6
        sgridtot(l+(i-1)*6)=sgrid(i)+dsgrid(l)/10;
    end
end
% Il faut adapter dsgrid et dTkapitza aux donnes kapitza-dirac disponibles

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%    Chargement et normalisation des donnes kapitza correspondantes    %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%Dossier dans lequel sont les fichiers kapitza :
KapDir='C:\Users\Fortun\Documents\Datas\0116\Calibration_semaine_du_18_janvier_2016\RamanNath\dataskapitza';



%%%%%La matrice dataKap est organise comme suit : 
%%%%%    Ligne 1    q=prof1ordre0    q=prof1ordre1   ...   q=prof1ordren
%%%%%    ....  q=profNsordre0   q=profNsordre1   ...   q=profNsordren 
%%%%%
%%%%% Reste de la matrice : ligne 2  142 : 
%%%%%
%%%%%   ordre               0            1      ...        n
%%%%% profondeur  1   2   ....  Ns 1  2  ... Ns ...  1  2 ...  Ns
%%%%%  
%%%%% tpulse=0  | *   *   ....  *  *  *  ...  * ...  *  *  ...  * |
%%%%% tpulse=0.5| *   *   ....  *  *  *  ...  * ...  *  *  ...  * |
%%%%% tpulse=1  | *   *   ....  *  *  *  ...  * ...  *  *  ...  * |
%%%%%   ...     |                     .....                       |
%%%%%   ...     |                     .....                       |
%%%%%   ...     |                     .....                       |
%%%%% tpulse=70 | *   *   ....  *  *  *  ...  * ...  *  *  ...  * |
%%%%%
%%%%%

%datakap=zeros(length(A),Ns*n);

for j=0:n
    j
    for i=1:Nsm
        i
        for l=1:6
            if l==1 
                A=importdata(strcat(KapDir,'/kapitzanormq',num2str(sgrid(i)),'P',num2str(j),'.txt'));
                datakap(1:length(A),l+(i-1)*6+j*Ns)=A(:)./max(A(1:(Ntemps-1)*Dtemps/dTkapitza+1));
            else
                A=importdata(strcat(KapDir,'/kapitzanormq',num2str(floor(sgrid(i))),'p',num2str(dsgrid(l)),'P',num2str(j),'.txt'));
            datakap(1:length(A),l+(i-1)*6+j*Ns)=A(:)./max(A(1:(Ntemps-1)*Dtemps/dTkapitza+1));
            end
        end
    end
end

Tgridkapitza=(0:length(A))*dTkapitza;
datakapres=zeros(Ntemps,Ns*(n+1));
Tgridkapitzares=zeros(Ntemps,1);


%On ne choisi que les points qui conresspondent  un point exprimental
for t=1:Ntemps
    datakapres(t,:)=datakap(2*Dtemps*(t-1)+1,:);
    Tgridkapitzares(t)=Tgridkapitza(2*Dtemps*(t-1)+1);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                   Calcul du rsidu                                    %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%Ecart entre les donnes exprimentales et la prdiction thorique par
%%%%%%kapitza dirac : r2(tpulse)=Xexp(tpulse)-Xkapitza(tpulse)
%%%%%%
%%%%%% La matrice r2 est organise comme suis : 
%%%%%%
%%%%%   ordre        -n      ...    -1       0      ...    n
%%%%% profondeur  1 ... Ns  ...  1 ... Ns 1 ... Ns  ... 1 ... Ns
%%%%%  
%%%%% t=0       | * ... *   .... * ... *  * ...  *  ... * ... *  |
%%%%% t=Dtemps  | * ... *   .... * ... *  * ...  *  ... * ... *  |
%%%%% t=2Dtemps | * ... *   .... * ... *  * ...  *  ... * ... *  |
%%%%%   ...     |                     .....                      |
%%%%%   ...     |                     .....                      |
%%%%%   ...     |                     .....                      |
%%%%% t=tmax    | * ... *   .... * ... *  * ...  *  ... * ... *  |
%%%%%
%%%%%

r2=zeros(Ntemps,Ns*ntot);
MSE=zeros(1,Ns*ntot);

for j=0:ntot-1
    for i=1:Ns
        r2(:,i+j*Ns)=(DataExp(:,j+1)-datakapres(:,i+abs(n-j)*Ns)).^2;
        MSE(i+j*Ns)=sum(r2(:,i+j*Ns));
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%               Comparaison des diffrents rsidus                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

indicordre=zeros(1,ntot);
skapordre=zeros(1,ntot);
for j=0:ntot-1
    MSEpart=MSE(1+j*Ns:(j+1)*Ns);
    [a,b]=min(MSEpart);
    indicordre(j+1)=b;
    skapordre(j+1)=sgridtot(b);
end

skapmoy=mean(skapordre)
skapvar=var(skapordre)



MSEmoy=zeros(1,Ns);
for j=0:ntot-1
    for i=1:Ns
        if j==0
            MSEmoy(i)=MSE(i);
        else
            MSEmoy(i)=MSEmoy(i)+MSE(i+j*Ns);
        end
    end
end


[MSEmoymin,imin]=min(MSEmoy);
skap=sgridtot(imin)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                   Plot du meilleur accord                             %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1)

for j=0:ntot-1
    subplot(n,3,j+1)
    plot(Tgrid,DataExp(:,j+1),'b+','linewidth',2)
    hold on
    plot(Tgridkapitza(1:(Ntemps-1)*Dtemps/dTkapitza+1),datakap(1:(Ntemps-1)*Dtemps/dTkapitza+1,imin+abs(n-j)*Ns),'g--','linewidth',3)
    hold on
    plot(Tgrid,FitRN(2,j+1)*besselj(abs(n-j),FitRN(5,j+1)*Tgrid).^2,'r--','linewidth',2)
    title(strcat('ordre +',num2str(n-j)))
    xlabel('Temps d interaction (s)')
     hold off
end











        
    
